﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.UI.Scheduler.Dialogs;

namespace _294405
{
    public partial class CustomAppointmentEditForm : EditAppointmentDialog
    {
        public CustomAppointmentEditForm()
        {
            InitializeComponent();
        }

        protected override void LoadSettingsFromEvent(IEvent ev)
        {
            base.LoadSettingsFromEvent(ev);

            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                this.radTextBox1.Text = appointmentWithEmail.CustomField.ToString();
            }
        }

        protected override void ApplySettingsToEvent(IEvent ev)
        {
            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                appointmentWithEmail.CustomField = Convert.ToInt32(this.radTextBox1.Text);
            }
            base.ApplySettingsToEvent(ev);
        }

        protected override IEvent CreateNewEvent()
        {
            return new AppointmentWithEmail();
        }
    }

    public class AppointmentWithEmail : Appointment
    {
        public AppointmentWithEmail() : base()
        {
        }

        private int customField = -1;

        public int CustomField
        {
            get
            {
                return this.customField;
            }
            set
            {
                if (this.customField != value)
                {
                    this.customField = value;
                    this.OnPropertyChanged("CustomField");
                }
            }
        }
    }

    public class CustomAppointmentFactory : IAppointmentFactory
    {
        #region IAppointmentFactory Members
        
        public IEvent CreateNewAppointment()
        {
            return new AppointmentWithEmail();
        }
    
        #endregion
    }
}